# Copyright: 2006 Brian Harring <ferringb@gmail.com>
# License: GPL2/BSD

from pkgcore.sync import base, bzr
from pkgcore.test.sync import make_bogus_syncer, make_valid_syncer
from snakeoil.test import TestCase

bogus = make_bogus_syncer(bzr.bzr_syncer)
valid = make_valid_syncer(bzr.bzr_syncer)


class TestBzrSyncer(TestCase):

    def test_uri_parse(self):
        self.assertEqual(bzr.bzr_syncer.parse_uri("bzr+http://dar"),
            "http://dar")
        self.assertRaises(base.uri_exception, bzr.bzr_syncer.parse_uri,
            "bzr://dar")
        self.assertRaises(base.syncer_exception, bogus,
            "/tmp/foon", "bzr+http://foon.com/dar")
        o = valid("/tmp/foon", "bzr+http://dar")
        self.assertEqual(o.uri, "http://dar")
