# Copyright: 2006 Brian Harring <ferringb@gmail.com>
# License: GPL2/BSD

from pkgcore.sync import base, hg
from pkgcore.test.sync import make_bogus_syncer, make_valid_syncer
from snakeoil.test import TestCase

bogus = make_bogus_syncer(hg.hg_syncer)
valid = make_valid_syncer(hg.hg_syncer)


class TestHgSyncer(TestCase):

    def test_uri_parse(self):
        self.assertEqual(hg.hg_syncer.parse_uri("hg+http://dar"),
            "http://dar")
        self.assertEqual(hg.hg_syncer.parse_uri("mercurial+http://dar"),
            "http://dar")
        self.assertRaises(base.uri_exception, hg.hg_syncer.parse_uri,
            "hg://dar")
        self.assertRaises(base.syncer_exception, bogus,
            "/tmp/foon", "hg+http://foon.com/dar")
        o = valid("/tmp/foon", "hg+http://dar")
        self.assertEqual(o.uri, "http://dar")
